(function() {
    'use strict';

    const router = require('router');
    var ivStore = require('/module/server/ivStore');

    //clears configuration
    router.delete('/config', (req, res) => {
        ivStore.deleteConfig((response) => {
            if (!response.success) {
                res.status('500').send(response.error);
                return;
            };
            res.status(200).send();
        });
    });

    //saves config
    router.post('/config', (req, res) => {
        ivStore.setConfig(req.params, (response) => {
            if (!response.success) {
                res.status('500').send(response.error);
                return;
            }
            res.json(response.data);
        });
    });

    //retrieves current configuration plus a few other details
    router.get('/settings', (req, res) => {
        ivStore.getSettings((settings) => {
            res.json(settings);
        })
    });

    router.get('/', (req, res) => {
        ivStore.getSettings((settings) => {
            res.render(settings);
        });
    });
})();