import { ConfigUI } from "./ConfigUI";
import { ISettings } from "./Settings";

export class ConfigPanelUI extends ConfigUI {
    $panel: JQuery<HTMLElement>;
    private _disabled:boolean=false;
    constructor(settings: ISettings, id: string) {
        super(settings);
        this.$panel = $("#" + id);
    }
    init() {
    }
    isEnabled():boolean{
        return !this._disabled;
    }
    setEnabled(enabled: boolean) {
        this._disabled=!enabled;
        if (enabled) {
            this.$panel.show();
        } else {
            this.$panel.hide();
        }
    }
}