declare namespace ImageVault
{


	export class Client {
	    core: any;
	    authUrl: string;
	    username: string;
	    password: string;
	    authMethod: string;
	    impersonate_as: any;
	    roles: any;
	    authToken: any;
	    accessToken: any;
	    _lastError: any;
	    grant_type: any;
	    resourceOwnerUsername: any;
	    resourceOwnerPassword: any;
	    sessionToken: any;
	    constructor(config: any);
	    json(service: any, args: any, callback: any): void;
	    html(service: any, args: any, callback: any): void;
	    _innerCall(service: any, args: any, callback: any, config: any): void;
	    _makeAbsoluteUrl(url: any): any;
	    _callServiceWithToken(token: any, service: any, args: any, callback: any, config: any): void;
	    _reauthenticateUsingActiveAuthentication(callback: any): void;
	    _ajaxWithCorsSupport(config: any): void;
	    _getAuthToken(callback: any): void;
	    getLastErrorMessage(): any;
	    _Base64: {
	        _keyStr: string;
	        encode: (input: any) => string;
	        decode: (input: any) => string;
	        _utf8_encode: (string: any) => string;
	        _utf8_decode: (utftext: any) => string;
	    };
	}
	export class Editor {
	    static openEditorInstance(inputParameters: InputParameters): void;
	}
	export class ImageEditor {
	    $imageobj: JQuery;
	    overlay: any;
	    $outline: JQuery;
	    $selection: JQuery;
	    $selectionImage: JQuery;
	    $workspace: JQuery;
	    $nwResizeHandler: JQuery;
	    $swResizeHandler: JQuery;
	    $seResizeHandler: JQuery;
	    $neResizeHandler: JQuery;
	    $nResizeHandler: JQuery;
	    $sResizeHandler: JQuery;
	    $wResizeHandler: JQuery;
	    $eResizeHandler: JQuery;
	    $cropWarningImage: JQuery;
	    $reloadEditorButton: JQuery;
	    $slider: JQuery;
	    $loader: JQuery;
	    changeSelectionImageTimout: any;
	    maxWidthForEditImage: number;
	    maxHeightForEditImage: number;
	    cropCoordinates: {
	        top: number;
	        left: number;
	        height: number;
	        width: number;
	        scale: number;
	        topFromImage: number;
	        leftFromImage: number;
	        unscaledWidth: number;
	        unscaledHeight: number;
	    };
	    cropAspectRatio: number;
	    zoomLevel: number;
	    originalZoomLevel: number;
	    step: number;
	    aspectRatio: number;
	    oldImageWidthCtrlValue: any;
	    oldImageHeightCtrlValue: any;
	    dragImage: boolean;
	    dragHandler: boolean;
	    currentHandle: any;
	    mouseX: number;
	    mouseY: number;
	    cropareaBorderWidth: number;
	    overlayOpacity: number;
	    outlineOpacity: number;
	    firstTime: boolean;
	    editorSliderHeight: number;
	    workspaceHeight: number;
	    workspaceWidth: number;
	    $editorSlider: any;
	    $editorAction: any;
	    $inputImageWidth: any;
	    $inputImageHeight: any;
	    mediaData: {
	        compressedJpegMediaUrl: any;
	        compressedWebSafeMediaUrl: any;
	        originalMediaFileFormat: any;
	        originalMediaWidth: any;
	        originalMediaHeight: any;
	    };
	    $labelImageWidth: JQuery;
	    $labelImageHeight: JQuery;
	    $actionSaveEditor: JQuery;
	    $actionCancelEditor: JQuery;
	    config: Config;
	    constructor(config: Config);
	    createImageData(): void;
	    showLoader(): void;
	    hideLoader(): void;
	    setSelectionImageEvent(): void;
	    setSelectionImage(): void;
	    setEditImageUrl(): void;
	    setupDom(): void;
	    calculateWorkSpaceHeight(): number;
	    setupLanguage(): void;
	    setupWindowSize(): void;
	    resizeOverlay(): void;
	    resizeCropArea(coord: any): void;
	    updateKeepAspectRatio(keepAspectRatio: any): void;
	    updateKeepAspectRatioIcon(mode: any): void;
	    updateEffects(currentEffects: any): void;
	    updateSelection(): void;
	    resizeImage(): void;
	    zoomImage(delta: any, zoomLevel: any): boolean;
	    updateCurrentEffects(): void;
	    updateWidthAndHeightControls(): void;
	    applyWidth(input: any): void;
	    applyHeight(input: any): void;
	    centerCropAreaOnImage(self: ImageEditor): void;
	    setSizeAndCenterImageInCropArea(self: ImageEditor): void;
	    positionResizeHandle($handle: any, position: any, display: any): void;
	    private updateResizeHandlers;
	    registerEvents(): void;
	    private zoomImageInternal;
	    private adjustCropAreaAndImage;
	    private adjustRange;
	}
	export class InputParameters {
	    currentEffects: any;
	    id: number;
	    editorSettings: any;
	    originalFormat: any;
	    originalFormatContentType: any;
	    originalFormatUrl: string;
	    keepAspectRatio: boolean;
	    coreSettings: CoreSettings;
	    languageSettings: any;
	    callback: (callback: any, element?: any) => void;
	    nodeInfo: {
	        x: number;
	        y: number;
	        navPaneWidth: number;
	        containerBorderWidth: number;
	        menuOffset: number;
	        contentWidth: number;
	    };
	    resizeMode: number;
	    targetFormat: any;
	}
	export class CoreSettings {
	    client: any;
	    mediaUrlBase: any;
	    useMediaAuthenticationParameter: any;
	}
	export class Config {
	    imageId: number;
	    client: any;
	    $domobj: any;
	    $preloadobj: JQuery;
	    editorWidth: number;
	    editorHeight: number;
	    originalImageWidth: number;
	    originalImageHeight: number;
	    originalFormatContentType: any;
	    originalFormatUrl: string;
	    originalUrl: string;
	    keepAspectRatio: boolean;
	    mediaUrlBase: any;
	    currentEffects: IEffect[];
	    resizeMode: number;
	    propertyWidth: number;
	    propertyHeight: number;
	    ivCoreProxy: string;
	    ivUiAuthUrl: string;
	    publishingIdentifier: string;
	    editorPopupMode: string;
	    nodeInfo: {
	        x: number;
	        y: number;
	        navPaneWidth: number;
	        containerBorderWidth: number;
	        menuOffset: number;
	        contentWidth: number;
	    };
	    editorDisabledOriginalFormatNotSupported: string;
	    editorDisabledOriginalToSmall: string;
	    editorDisabledNoAccessToMedia: string;
	    editorWidthInputLabel: string;
	    editorHeightInputLabel: string;
	    editorOkButtonText: string;
	    editorCancelButtonText: string;
	    editorWarningIconText: string;
	    editorReloadButtonText: string;
	    editorLoadErrorText: string;
	    errorCallingImageVault: string;
	    errorCallingImageVaultRetrying: string;
	    errorCallingImageVaultGaveUp: string;
	    title: string;
	    useMediaAuthenticationParameter: any;
	    callback(callback: any, element?: any): void;
	    getCurrentEffect(type: any): IEffect;
	    getCurrentCropEffect(): CropEffect;
	    getCurrentResizeEffect(): ResizeEffect;
	    getCurrentTrimEffect(): TrimEffect;
	    executeActionWithRetryAndInformOnPreload(action: (retryLogic: IRetryLogic) => void, maxRetries?: number): void;
	    showErrorOnPreloadScreen(title: string, message: string): void;
	    addAssetUrlParameters(url: string): string;
	}
	export interface IRetryLogic {
	    retry(): boolean;
	}
	export interface ISize {
	    width?: number;
	    height?: number;
	}
	export interface IEffect {
	    $type: string;
	}
	export class ResizeEffect implements IEffect {
	    static typeName: string;
	    static assemblyName: string;
	    $type: string;
	    Width: number;
	    Height: number;
	    ResizeMode: number;
	    constructor(width: number, height: number, resizeMode: number);
	}
	export class CropEffect implements IEffect {
	    static typeName: string;
	    static assemblyName: string;
	    $type: string;
	    X: number;
	    Y: number;
	    Width: number;
	    Height: number;
	    constructor(x: number, y: number, width: number, height: number);
	}
	export class TrimEffect implements IEffect {
	    static typeName: string;
	    static assemblyName: string;
	    $type: string;
	    Start: number;
	    Stop: number;
	    constructor(start: number, stop: number);
	}
	export class ChangeOutputFormatEffect implements IEffect {
	    static typeName: string;
	    static assemblyName: string;
	    $type: string;
	    ContentType: string;
	    constructor(contentType: string);
	}
	export interface ICropArea {
	    width: number;
	    height: number;
	    x: number;
	    y: number;
	    z: number;
	}
	export class EffectUtil {
	    static applyCrop(cropArea: ICropArea, x: number, y: number, width: number, height: number): void;
	    static applyResize(cropArea: ICropArea, width: number, height: number, resizeMode: number, zoomOnly?: boolean): void;
	    static toString(ca: ICropArea): string;
	}
	export class MediaFormatBase {
	    $type?: string;
	    MediaFormatOutputType?: MediaFormatOutputType;
	    Id?: number;
	    Name?: string;
	    SystemFormat?: boolean;
	}
	export enum MediaFormatOutputType {
	    Unknown = 9999,
	    WebSafe = 0,
	    Jpeg = 1,
	    Tiff = 2,
	    Png = 4,
	    Gif = 5,
	    Original = 6
	}
	export class OriginalFormat extends MediaFormatBase {
	    constructor();
	}
	export abstract class TransformableMediaFormat extends MediaFormatBase {
	    Effects: IEffect[];
	}
	export class WebMediaFormat extends TransformableMediaFormat {
	    static typeName: string;
	    static assemblyName: string;
	    $type: string;
	    Width?: number;
	    Height?: number;
	    AspectRatio?: number;
	    constructor(effects?: IEffect[]);
	}
	export class ThumbnailFormat extends WebMediaFormat {
	    static typeName: string;
	    static assemblyName: string;
	    $type: string;
	}
	export class ImageFormat extends ThumbnailFormat {
	    static typeName: string;
	    static assemblyName: string;
	    $type: string;
	    CompressionQuality: number;
	    constructor(mediaFormatOutputType?: MediaFormatOutputType, compressionQuality?: number, effects?: IEffect[]);
	}
	export class VideoEditor {
	    editableMediaUrl: any;
	    editableMediaContentType: any;
	    editableMediaWebmUrl: any;
	    editableMediaWebmContentType: any;
	    config: Config;
	    constructor(config: Config);
	    initPlayerDone(): void;
	    setupDom(): void;
	    setupVideoTag(start: any, stop: any): void;
	    loadEditableMedia(callback: any): void;
	    updateCurrentEffects(): void;
	}

	export interface IClientCredentialsClientProps extends IClientProps {
	    impersonateAs?: IImpersonateDetails;
	}
	export interface IImpersonateDetails {
	    username: string;
	    roles?: string[];
	}
	export class ClientCredentialsClient extends BaseClient {
	    props: IClientCredentialsClientProps;
	    constructor(props: IClientCredentialsClientProps);
	    getAccessCode(async: boolean, resolve: (response: IAccessCodeResponse) => void, reject: (error: IClientError) => void): void;
	    requestAccessToken(async: boolean, resolve: (response: IAccessToken) => void, reject: (error: IClientError) => void): void;
	}
	export interface IClientProps {
	    ivUrl: string;
	    clientIdentityAuth: string;
	}
	export interface IAccessTokenResponse {
	    refresh_token: string;
	    access_token: string;
	    token_type: string;
	}
	export interface IAccessToken {
	    accessToken: string;
	}
	export interface IAccessCodeResponse {
	    code: string;
	}
	interface IAjaxCallConfig {
	    headers: {
	        [key: string]: string;
	    };
	    async: boolean;
	    method: string;
	    url: string;
	    dataType: string;
	    success: (response: any) => void;
	    error: (xhr: IJQXhr, status: string, error: string) => void;
	    contentType?: string;
	    data?: any;
	}
	export abstract class BaseClient {
	    apiUrl: string;
	    props: IClientProps;
	    settings: ClientSettings;
	    redirectUrl: string;
	    accessCodeResponse: IAccessCodeResponse;
	    constructor(props: IClientProps);
	    _call<T>(options: CallOptions, resolve: (result: T) => void, reject: (error: IClientError) => void): void;
	    _ajax(config: IAjaxCallConfig): void;
	    formUrlEncodeObject(data: any, key?: string, list?: string[]): string;
	    getAccessTokenPromise: Promise<IAccessToken>;
	    getAccessTokenSync(resolve: (response: IAccessToken) => void, reject: (error: IClientError) => void, tokenFailures: number): void;
	    getAccessToken(async: boolean): Promise<IAccessToken>;
	    abstract getAccessCode(async: boolean, resolve: (response: IAccessCodeResponse) => void, reject: (error: IClientError) => void): void;
	    _getAccessToken(async: boolean, resolve: (response: IAccessToken) => void, reject: (error: IClientError) => void, tokenFailures: number): void;
	    requestAccessToken(async: boolean, resolve: (response: IAccessToken) => void, reject: (error: IClientError) => void): void;
	    callWithUserAuth<T>(options: CallOptions, resolve: (result: T) => void, reject: (error: IClientError) => void): void;
	    callWithUserAuthSync<T>(options: CallOptions, resolve: (result: T) => void, reject: (error: IClientError) => void): void;
	    get<T>(path: string, resolve: (result: T) => void, reject: (error: IClientError) => void): void | Promise<T>;
	    private processPostOptions;
	    post<T>(options: CallOptions, resolve: (result: T) => void, reject: (error: IClientError) => void): void | Promise<T>;
	    postSync<T>(options: CallOptions): T;
	    getCachedAccessToken(): string;
	    json<T>(path: string, argument: any, resolve: (result: T) => void, reject: (error: IClientError) => void): void | Promise<T>;
	    hasCachedCredentials(): boolean;
	    removeCachedCredentials(): void;
	}
	export interface IClient {
	    json<T>(path: string, argument: any, resolve: (result: T) => void, reject: (error: IClientError) => void): void;
	    post<T>(options: CallOptions, resolve: (result: T) => void, reject: (error: IClientError) => void): void;
	    get<T>(path: string, resolve: (result: T) => void, reject: (error: IClientError) => void): void;
	    postSync<T>(options: CallOptions): T;
	    hasCachedCredentials(): boolean;
	    removeCachedCredentials(): void;
	}
	export interface IClientError {
	    error: IError;
	    jqXHR?: IJQXhr;
	}
	export interface IJQXhr {
	    responseJSON?: any;
	    status: number;
	}
	interface IError {
	    message: string;
	    stack?: string;
	    name?: string;
	    code?: number;
	}
	export class CallOptions {
	    path: string;
	    method?: string;
	    dataType?: string;
	    auth?: string;
	    contentType?: string;
	    data?: any;
	    async?: boolean;
	}
	export class Util {
	    static has(object: any, key: string): boolean;
	    static get(object: any, key: string, defaultValue: any): any;
	    static formatString(str: string, ...args: string[]): string;
	    static htmlEncode(str: string): string;
	}
	export class ClientSettings extends Settings {
	    private static readonly accessTokenKey;
	    private static readonly refreshTokenKey;
	    getAccessToken(): string;
	    setAccessToken(accessToken: string): void;
	    getRefreshToken(): string;
	    setRefreshToken(refreshToken: string): void;
	}
	export class Settings {
	    name: string;
	    storage: ILocalStorage;
	    constructor(name: string);
	    loadSettings(key: string, defaultValue: any): any;
	    saveSetting(key: string, value: any): void;
	}
	interface ILocalStorage {
	    getItem(key: string): any;
	    setItem(key: string, value: any): any;
	}
	export class MetadataDefinitionService {
	    static Find(client: IClient, q: MetadataDefinitionQuery): Promise<MetadataDefinition[]>;
	}
	export class MetadataDefinitionQuery {
	    Filter?: MetadataDefinitionFilter;
	    Populate?: MetadataDefinitionPopulationQuery;
	}
	export class MetadataDefinitionFilter extends IVFilter {
	    Id?: number;
	    MetadataDefinitionType?: MetadataDefinitionType;
	    MetadataType?: MetadataType;
	}
	export class MetadataDefinitionPopulationQuery {
	    SourceMetadataDefinitions: boolean;
	}
	export class MetadataDefinition {
	    Id: number;
	    Description: string;
	    IsMultilingual: boolean;
	    IsReadOnly: boolean;
	    MetadataDefinitionType: MetadataDefinitionType;
	    MetadataType: MetadataType;
	    Name: string;
	    SourceMetadataDefinitions?: MetadataDefinitionMapping[];
	    SymbolKey: string;
	}
	export class MetadataDefinitionMapping {
	    MetadataDefinition: MetadataDefinition;
	    Priority: number;
	}
	export enum MetadataType {
	    Undefined = 0,
	    String = 1,
	    DateTime = 2,
	    Integer = 3,
	    Boolean = 4,
	    LongString = 5,
	    Decimal = 6
	}
	export enum MetadataDefinitionType {
	    Undefined = 0,
	    System = 1,
	    User = 2,
	    Iptc = 3,
	    Exif = 4,
	    Xmp = 5,
	    Id3V1 = 6,
	    Id3V2 = 7,
	    Riff = 8,
	    Jfif = 9,
	    Gps = 10,
	    PhotoshopIrb = 11,
	    FlashPix = 12,
	    Afcp = 13,
	    GeoTiff = 14,
	    IccProfile = 15,
	    WindowsMedia = 16,
	    PdfDocInfo = 17,
	    Dicom = 100,
	    ThirdParty = 101,
	    YouTube = 102,
	    Vidispine = 103,
	    Spotify = 104,
	    Custom = 200,
	    Image = 201,
	    Video = 202,
	    Audio = 203,
	    Document = 204,
	    MakerNotesCanon = 1001,
	    MakerNotesCasio = 1002,
	    MakerNotesFujiFilm = 1003,
	    MakerNotesGe = 1004,
	    MakerNotesHp = 1005,
	    MakerNotesJvcVictor = 1006,
	    MakerNotesKodak = 1007,
	    MakerNotesLeaf = 1008,
	    MakerNotesMinoltaKonicaMinolta = 1009,
	    MakerNotesNikon = 1010,
	    MakerNotesOlympusEpson = 1011,
	    MakerNotesPanasonicLeica = 1012,
	    UserDefined1 = 10001,
	    UserDefined2 = 10002,
	    UserDefined3 = 10003,
	    UserDefined4 = 10004,
	    UserDefined5 = 10005,
	    UserDefined6 = 10006,
	    UserDefined7 = 10007,
	    UserDefined8 = 10008,
	    UserDefined9 = 10009
	}
	export class IVFilter {
	    Skip?: number;
	    Take?: number;
	}
	export class AssetService {
	    static info(client: IClient): Promise<IAssetInfo>;
	    static get(client: IClient, request: IAssetRequest): Promise<IAssetResponse>;
	}
	export interface IAssetInfo {
	    searchEnabled: boolean;
	}
	export interface IAssetRequest {
	    $search?: string;
	    $top?: number;
	    $skip?: number;
	    $count?: boolean;
	    $select?: string;
	    $orderby?: string;
	    $filter?: string;
	}
	export interface IAssetResponse {
	    "@odata.count": number;
	    value: Array<IAsset>;
	}
	export interface IAsset {
	    name?: string;
	    id?: string;
	    symbols?: AssetSymbol[];
	    vaultId?: number;
	    modified?: string;
	    modifiedBy?: string;
	    versionId?: number;
	    isShared?: boolean;
	    isPublished?: boolean;
	    contentType?: string;
	    conversions?: AssetConversion[];
	    metadata?: AssetMetadata[];
	    access?: VaultRoles;
	    canBeDownloaded?: boolean;
	    agreementId?: number[];
	    categories?: AssetCategory[];
	}
	export class AssetCategory {
	    id?: number;
	    name?: string;
	}
	export class AssetMetadata {
	    definitionId: number;
	    value: string;
	    booleanValue?: boolean;
	    dateValue?: string;
	    doubleValue?: number;
	    integerValue?: number;
	    language?: string;
	}
	export class AssetConversion {
	    formatId: number;
	    mediaInformation: string;
	    contentType: string;
	    url: string;
	    width: number;
	    height: number;
	}
	export class AssetSymbol {
	    symbol: string;
	    info?: AssetSymbolInfo[];
	}
	export class AssetSymbolInfo {
	    name: string;
	    value?: string;
	}
	export class VaultService {
	    static Find(client: IClient, query: VaultQuery): Promise<Vault[]>;
	}
	export class VaultQuery {
	    Filter?: VaultFilter;
	    Populate?: VaultPopulationQuery;
	}
	export class VaultFilter extends IVFilter {
	    Id?: number;
	    UserMinAccess?: VaultRoles;
	}
	export enum VaultRoles {
	    FullControl = 7,
	    Contribute = 3,
	    View = 1,
	    None = 0,
	    AccessRightsWrite = 2,
	    AccessRightsAdmin = 4
	}
	export class VaultPopulationQuery {
	    AccessList: boolean;
	    CurrentUserRole: boolean;
	    MetadataDefinitions: boolean;
	}
	export class Vault {
	    Id: number;
	    Name: string;
	    Description: string;
	}
	export class UriUtil {
	    static toQueryString(q: any): string;
	}
	export class CategoryService {
	    static getCategories(client: IClient): Promise<Category[]>;
	}
	export class Category {
	    Name: string;
	    Id: number;
	    IsUsed?: boolean;
	    ParentId?: number;
	    Categories?: Category[];
	}
	export class MediaService {
	    static Find(client: IClient, query: MediaItemQuery): Promise<MediaItem[]>;
	    static FindSync(client: IClient, query: MediaItemQuery): MediaItem[];
	}
	export class MediaItemQuery {
	    Filter: MediaItemFilter;
	    Populate: MediaItemPopulationQuery;
	    MediaUrlBase: string;
	}
	export class MediaItemFilter extends IVFilter {
	    Id?: number[];
	    SearchString?: string;
	    CategoryId?: number[];
	    AgreementId?: number[];
	    CollectionId?: number[];
	    MediaItemState?: MediaItemStates;
	    SortOrder?: MediaItemSortOrders;
	    VaultId?: number[];
	    Url?: string[];
	}
	export enum MediaItemSortOrders {
	    None = 0,
	    Name = 1,
	    NameDescending = 2,
	    DateAdded = 3,
	    DateAddedDescending = 4,
	    MediaItemId = 5,
	    MediaItemIdDescending = 6
	}
	export enum MediaItemStates {
	    CreatedInCore = 0,
	    MetadataAnalyzed = 1,
	    OriginalContentStored = 2,
	    AnalyzedAndStored = 3,
	    MetadataOrganized = 4,
	    MediaReadyToUse = 7
	}
	export class MediaItemPopulationQuery {
	    MediaFormats?: MediaFormatBase[];
	    PublishInfo?: PublishInfo;
	    Metadata?: MetadataQuery[];
	    Agreements?: boolean;
	    Access?: boolean;
	    CanBeDownloaded?: boolean;
	    Categories?: boolean;
	    DuplicateVersionId?: boolean;
	    StorageInformation?: boolean;
	    Shared?: boolean;
	    PublishInformation?: boolean;
	    PublishDetails?: boolean;
	}
	export class MetadataQuery {
	    Filter: MetadataFilter;
	}
	export class MetadataFilter extends IVFilter {
	    MetadataDefinitionId?: number;
	    IsDefinedInVault?: boolean;
	    MetadataDefinitionType?: MetadataDefinitionType;
	    IsNull?: boolean;
	}
	export class PublishInfo {
	    PublishIdentifier: string;
	    PublishDetails?: string;
	}
	export class MediaItem {
	    Id: number;
	    VaultId: number;
	    MediaConversions: Array<Media>;
	    Name: string;
	    State: AssetStates;
	    Agreements?: AgreementListData[];
	    Metadata?: Metadata[];
	    DateAdded: string;
	    AddedBy: string;
	    Categories?: Category[];
	}
	export class Category {
	    Id: number;
	    Name: string;
	    IsUsed?: boolean;
	    ParentId?: number;
	    Categories?: Category[];
	}
	export class Metadata {
	    $type: string;
	    MetadataDefinitionId: number;
	    DefinitionType: MetadataDefinitionType;
	    Name: string;
	    Value?: any;
	    LanguageId?: number;
	    IsNull?: boolean;
	    SymbolKey?: string;
	}
	export class AgreementListData {
	    AgreementIdentifier: string;
	    Comment: string;
	    DateCreated: string;
	    DocumentLink: string;
	    Id: number;
	    LegalBasis: LegalBasis;
	    ValidToDate?: any;
	    string: any;
	}
	export enum LegalBasis {
	    Consent = 1,
	    Agreement = 2,
	    LegalObligation = 3,
	    ProtectRegistrantsVitalInterests = 4,
	    PublicInterest = 5,
	    LegitimateInterest = 6
	}
	export enum AssetStates {
	    None = 0,
	    MediaShared = 1,
	    MediaPublished = 2
	}
	export class Media {
	    Html: string;
	    ContentType: string;
	    Url: string;
	    Name: string;
	    MediaFormatName: string;
	    MediaFormatId: number;
	    IsFileIcon: boolean;
	    Id: number;
	}
	export class WebMedia extends Media {
	    Width: number;
	    Height: number;
	}
	export class MediaFormatService {
	    static Find(client: IClient, q: MediaFormatQuery): Promise<MediaFormatBase[]>;
	}
	export class MediaFormatQuery {
	    Filter?: MediaFormatFilter;
	    Populate?: MediaFormatPopulationQuery;
	}
	export class MediaFormatFilter extends IVFilter {
	    Format?: MediaFormatBase;
	}
	export class MediaFormatPopulationQuery {
	    IsInUse?: boolean;
	}
	interface IAuthorizePinCodeResponse {
	    pin: string;
	}
	interface IAuthorizePollPinCodeResponse {
	    state: string;
	    code: string;
	}
	export enum ActivationResponseState {
	    tentative = 0,
	    completed = 1,
	    error = 2
	}
	export class ActivationResponse {
	    state: ActivationResponseState;
	    htmlMessage: string;
	}
	export interface IPinClientProps extends IClientProps {
	    activationCallback: (response: ActivationResponse) => void;
	    i18n?: IPinClientTexts;
	}
	export interface IPinClientTexts {
	    pin_code_request_no_valid_pin_code: string;
	    poll_pin_failed_async_is_not_supported: string;
	    poll_pin_code_returned_state_x: string;
	    no_access_code_was_returned_from_poll_code_response: string;
	    activation_completed: string;
	    activation_is_required_go_to_x_to_activate: string;
	}
	export class PinClient extends BaseClient implements IClient {
	    defaultTexts: IPinClientTexts;
	    props: IPinClientProps;
	    activateUrl: string;
	    pin: string;
	    monitorPinCodeResolve: (response: IAuthorizePollPinCodeResponse) => void;
	    monitorPinCodeReject: (error: IClientError) => void;
	    monitorPinCodeTimeout: any;
	    accessCode: IAuthorizePollPinCodeResponse;
	    constructor(props: IPinClientProps);
	    pinCodeRequest(async: boolean, resolve: (response: IAuthorizePinCodeResponse) => void, reject: (error: IClientError) => void): void;
	    private translate;
	    pollPinCode(async: boolean, resolve: (response: IAuthorizePollPinCodeResponse) => void, reject: (error: IClientError) => void): void;
	    monitorPinCode(async: boolean, resolve: (response: IAuthorizePollPinCodeResponse) => void, reject: (error: IClientError) => void): void;
	    getAccessCode(async: boolean, resolve: (response: IAccessCodeResponse) => void, reject: (error: IClientError) => void): void;
	}
}